% remember to check fun.m w=_ (this term must coincide with degree of f)
% and set g(x,y)=...
% n = degree of legendre poly
% deg_g = degree of g(x,y)
% deg_f = degree of f
% nitx = number of interval in x-axis
% nity = number of interval in y-axis
% evaluate error you must input the exact solution in u.u_x,u_y and
% input the degree highest degree (I mean in x or y) of u (u_x,u_y can be omitted)

clear all
clc
format long

%-----------------------------------------------------------------------
%read coordinate
%this file read %listx=0:1/16:1;%listy=0:1/32:1;
fid=fopen('xyznsef.s.s1','r');
         [totalpoint,count]=fscanf(fid,'%d',[1 1]);
         [pmatrix,count]=fscanf(fid,'%e',[3 totalpoint]);%continute to read point from the document row2 to row 1+totalpoint
         pmatrix=pmatrix.';%real matrix transpose
         pmatrix=pmatrix(:,1:2);
         fclose(fid);
for ii=1:totalpoint
         if pmatrix(ii,1)==pmatrix(ii+1,1)
             y=pmatrix(1:ii+1,2);
             z=y;
         elseif pmatrix(ii,2)==pmatrix(ii+1,2)
             x=pmatrix(1:ii+1,1);
             z=x;
         else
           break;
         end
end
    if pmatrix(1,1)==pmatrix(length(z)+1,1)
        for ii=1:totalpoint/length(x)
            y(ii)=pmatrix(ii+(ii-1)*length(x),2);
        end
    elseif pmatrix(1,2)==pmatrix(length(z)+1,2)
        for ii=1:totalpoint/length(y)
            x(ii)=pmatrix(ii+(ii-1)*length(y),1);
        end
    else
         break;
    end
x=sort(x);
y=sort(y);
if size(x)==[1 length(x)]
    y=y.';
else
    x=x.';
end
listx=x;
listy=y;
clear x y z pmatrix totalpoint

%-----------------------------------------------------------------------
c11=1;
c22=1;
c12_1=0;
c12_2=0;


%listx=0:1/16:1;
%listy=0:1/32:1;
lex=length(listx);
ley=length(listy);
nitx=lex-1;
nity=ley-1;
%-----------------------------------------
% test0 u=1
%  deg_g=0;
%  deg_f=0;
%  deg_u=0;
%  n=1;

% test1 u=x
%  deg_g=1;
%  deg_f=0;
%  deg_u=1;
%  n=1;

%test2 u=y
% deg_g=1;
% deg_f=0;
% deg_u=1;
% n=1;

%test3 u=x*y;
% deg_g=1;
% deg_f=0;
% deg_u=1;
% n=1;

%test4 u=x+y+x*y;
% n=3;
% deg_g=1;
% deg_f=0;
% deg_u=1;

%test5 u=x^2;
% deg_g=2;
% deg_f=0;
% deg_u=2;
% n=2;%1

%test6 u=y^2;
% deg_g=2;
% deg_f=0;
% deg_u=2;
% n=2;%1

%test7 u=x^2*y;
% deg_g=2;
% deg_f=1;
% deg_u=2;
% n=2;%1

%test8 u=x*y^2;
% deg_g=2;
% deg_f=1;
% deg_u=2;
% n=2;%1

%test9 u=x^2*y^2;
% deg_g=2;
% deg_f=2;
% deg_u=2;
% n=2;%1

%test10 u=x^2+y^2+x^2*y+x*y^2+x^2*y^2;
% deg_g=2;
% deg_f=2;
% deg_u=2;
% n=4;%1

%test11 u=x^2+y^2+x^2*y+x*y^2+x^2*y^2+x+y+x*y;
deg_g=2;
deg_f=2;
deg_u=2;
n=2;%1

%test12 u=x^2+y^2+x^2*y+x*y^2+x^2*y^2+x+y+x*y+1;
% deg_g=2;
% deg_f=2;
% deg_u=2;
% n=2;%1

%test13 u=x^2+y^2;
% deg_g=2;
% deg_f=0;
% deg_u=2;
% n=2;%1
%--------------------------------
fprintf('n=%g\n',n)
%------------------------------------------------------------------

b=vectorgbn51any(n,deg_f,deg_g,c11,listx,listy)';
a=matrixmn20(n,c11,c22,c12_1,c12_2,listx,listy);

spparms('autommd',0); 
q = colamd(a);
A = a (:,q) \ b;
A(q) = A;
spparms('autommd',1);

clear a b

%{
%if you want to see the ux,uy,u in each block open the following comment
for j=1:nity
    for i=1:nitx
         syms x y
         xpp=(x-(listx(i)+listx(i+1))/2)*(2/(-listx(i)+listx(i+1)));
         yqq=(y-(listy(ley-j)+listy(ley+1-j))/2)*(2/(-listy(ley-j)+listy(ley+1-j)));
         indexofblock=i+(j-1)*nitx;
                iuxb=(indexofblock-1)*(n+1)^2+1;
                iuxe=indexofblock*(n+1)^2;
                iuyb=(nitx*nity+indexofblock-1)*(n+1)^2+1;
                iuye=(nitx*nity+indexofblock)*(n+1)^2;
                iub=(2*nitx*nity+indexofblock-1)*(n+1)^2+1;
                iue=(2*nitx*nity+indexofblock)*(n+1)^2;
         fprintf('q_hx%g=\n',indexofblock)
         disp(expand(vpa(polytwo(A(iuxb:iuxe),xpp,yqq))))
         fprintf('q_hy%g=\n',indexofblock)
         disp(expand(vpa(polytwo(A(iuyb:iuye),xpp,yqq))))
         fprintf('u_h%g=\n',indexofblock)
         disp(expand(vpa(polytwo(A(iub:iue),xpp,yqq))))
         clear xpp yqq indexofblock
    end
end
%}


% evaluate error 
%----------------------------------------------------------------------------------------
nu=max([2*n,n+deg_u,2*deg_u]);%deg_ux=;%deg_uy=;these two is useless here
erroru=zeros(1,nitx*nity);
errorux=zeros(1,nitx*nity);
erroruy=zeros(1,nitx*nity);
errorumaxtmp=zeros(nu,nu);
erroruxmaxtmp=zeros(nu,nu);
erroruymaxtmp=zeros(nu,nu);
errorumax=zeros(nitx*nity,1);
erroruxmax=zeros(nitx*nity,1);
erroruymax=zeros(nitx*nity,1);
[rho,tau]=gauleg(nu);
for indexj=1:nity
     for indexi=1:nitx
            indexofblock=indexi+(indexj-1)*nitx;
                alpha=listx(indexi);
                beta=listx(indexi+1);
                gamma=listy(ley-indexj);
                delta=listy(ley-indexj+1);

                rhoone=rho*((beta-alpha)/2)+(alpha+beta)/2;%node
                tauone=tau*(beta-alpha)/2;%weight
                rhotwo=rho*((delta-gamma)/2)+(delta+gamma)/2;%node
                tautwo=tau*(delta-gamma)/2;%weight

                errorux(indexofblock)=0;
                erroruy(indexofblock)=0;
                erroru(indexofblock)=0;
                iuxb=(indexofblock-1)*(n+1)^2+1;
                iuxe=indexofblock*(n+1)^2;
                iuyb=(nitx*nity+indexofblock-1)*(n+1)^2+1;
                iuye=(nitx*nity+indexofblock)*(n+1)^2;
                iub=(2*nitx*nity+indexofblock-1)*(n+1)^2+1;
                iue=(2*nitx*nity+indexofblock)*(n+1)^2;
         for qq=1:nu
                for pp=1:nu               
                    xpp=rho(pp);
                    yqq=rho(qq);
                 errorumax(indexofblock,pp,qq)=abs(u(rhoone(pp),rhotwo(qq))-polythree(A(iub:iue),xpp,yqq));
                 erroruxmax(indexofblock,pp,qq)=abs(u_x(rhoone(pp),rhotwo(qq))-polythree(A(iuxb:iuxe),xpp,yqq));
                 erroruymax(indexofblock,pp,qq)=abs(u_y(rhoone(pp),rhotwo(qq))-polythree(A(iuyb:iuye),xpp,yqq));
                 erroru(indexofblock)=erroru(indexofblock)+tautwo(qq)*tauone(pp)*(u(rhoone(pp),rhotwo(qq))-polythree(A(iub:iue),xpp,yqq))^2;
                 errorux(indexofblock)=errorux(indexofblock)+tautwo(qq)*tauone(pp)*(u_x(rhoone(pp),rhotwo(qq))-polythree(A(iuxb:iuxe),xpp,yqq))^2;
                 erroruy(indexofblock)=erroruy(indexofblock)+tautwo(qq)*tauone(pp)*(u_y(rhoone(pp),rhotwo(qq))-polythree(A(iuyb:iuye),xpp,yqq))^2;
                end
         end
    end        
end

ex=sqrt(sum(errorux));
ey=sqrt(sum(erroruy));
eu=sqrt(sum(erroru));

emx=max(max(max(erroruxmax,[],3),[],2));
emy=max(max(max(erroruymax,[],3),[],2));
emu=max(max(max(errorumax,[],3),[],2));
%
%x=[1000 1 3;30 2 5;7 9 100]
%max(x,[],1) xC椤̤j
%max(x,[],2) xCC̤j

%--------------------------------------------------------------------------
disp(' nitx    nity       ux(2-norm)                ux(max)              uy(2-norm)            uy(max)              u(2-norm)          u (max)')
disp(sprintf('%4d    %4d    %15.6e         %15.6e        %15.6e       %15.6e      %15.6e    %15.6e ',...
       nitx,nity,ex,emx,ey,emy,eu,emu));   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
% order
for jj=1:length(nit_loop)
        if (jj ==1)  
            ordu(jj)=0;
            ordux(jj)=0;
            orduy(jj)=0;
        else
            ordu(jj)=log(emu(jj)/emu(1))/log(nit_loop(1)/nit_loop(jj));
            ordux(jj)=log(emx(jj)/emx(1))/log(nit_loop(1)/nit_loop(jj));
            orduy(jj)=log(emy(jj)/emy(1))/log(nit_loop(1)/nit_loop(jj));
        end
end

disp('    nit    u-max-norm(nit)/max-norm(nit+1)    u-2-norm(nit)/2-norm(nit+1)   ux max-norm(nit)/max-norm(nit+1)   ux 2-norm(nit)/2-norm(nit+1)')
for nitloop=1:length(nit_loop)-1   
disp(sprintf('  %4d     %8.4f                          %8.4f                         %8.4f                        %8.4f',nit_loop(nitloop),emu(nitloop)/emu(nitloop+1),eu(nitloop)/eu(nitloop+1),emx(nitloop)/emx(nitloop+1),ex(nitloop)/ex(nitloop+1)));
end

disp('    nit       u Order       ux Order       uy Order')
for nitloop=1:length(nit_loop)-1   
disp(sprintf(' %4d        %8.4f      %8.4f       %8.4f',...
      nit_loop(nitloop),ordu(jj),ordux(jj),orduy(jj)));
end
%cf max-norm and 2-norm
%disp('    nit    u_x error(2-norm)< u_x error(max-norm)    u_y
%error(2-norm)< u_y error(max-norm)       u error(2-norm)< u error(max-norm)')
% for nitloop=1:length(nit_loop)
%     disp(sprintf('  %4d                   %4d                                      %4d                                       %4d',nitloop,ex(nitloop)< emx(nitloop),ey(nitloop)<emy(nitloop),eu(nitloop)<emu(nitloop)));

%end
%}